(*
	IV окружной этап Всероссийской олимпиады школьников по информатике
	24 - 28 марта 2006 г.
	г. Петрозаводск

	Задача A. Фигурное программирование
	Авторы: Р. Сошкин, А. Николаевский, В.А. Кузнецов
	Решение: А. Урбан
*)

{$apptype console}
{$O-,Q+,R+}
const
 fname='figure';
 fin=fname+'.in';
 fout=fname+'.out';
 MAXN=20;
 eps=5e-3;

var
 n, i, k, cur : longint;
 sum, curs, min, max : extended;
 mas : array[1..MAXN] of extended;
 was : array[1..MAXN] of boolean;

begin
 randseed:=65231;
 reset(input, fin); rewrite(output, fout);

 read(n, k);
 for i := 1 to n do read(mas[i]);
 read(sum);

 while (true) do
 begin
      fillchar(was, sizeof(was), false);
      for i := 1 to k do
      begin
           cur:=random(n)+1;
           while (was[cur]) do cur:=random(n)+1;
           was[cur]:=true;
      end;

      curs:=0.0; min:=1e10; max:=-1e10;
      for i := 1 to n do
       if (not was[i]) then
       begin
            curs:=curs+mas[i];
            if (min>mas[i]) then min:=mas[i];
            if (max<mas[i]) then max:=mas[i];
       end;

      curs:=curs-min-max;
      if (abs(sum-(curs/(n-k-2)))<eps) then
      begin
           write(min:0:2, ' ', max:0:2);
           for i := 1 to n do
            if (was[i]) then write(' ', mas[i]:0:2);
           exit;
      end;

 end;

end.